#include <afc/easygui/easygui.h>
#include <afc/easygui/widgets.h>

int btn_hello ( DynamicClass * dc, EasyGUIContext * context )
{
	fprintf ( stdout, "Hello world!\n" );

	afc_dynamic_class_execute ( dc, "enabled", FALSE, AFC_DYNAMIC_CLASS_ARG_END );
	// afc_easygui_widget_execute ( context, "win", "enabled", FALSE, AFC_DYNAMIC_CLASS_ARG_END );

	return ( 0 );
}

int btn_change ( DynamicClass * dc, EasyGUIContext * context )
{
	static int i;
	char * s;

	if ( i == 0 )
	{
		i = 1;
		s = "Label Changed";
	} else {
		i = 0;
		s = "Label Changed Again";
	}
		
	afc_easygui_widget_execute ( context, "btn_label", "change_text", s, AFC_EASYGUI_ARG_END );

	return ( 0 );
}

int main ( int argc, char * argv[] )
{
	AFC * afc = afc_new (); 
	EasyGUI * easygui = afc_easygui_new ( afc );
	EasyGUIContext * context;
	int afc_res = 0;

	if ( easygui == NULL ) 
	{
	  fprintf ( stderr, "Init of class EasyGUI failed.\n" );
	  return ( 1 );
	}

	afc_easygui_init ( easygui );
	context = afc_easygui_add_context ( easygui, NULL );

	afc_easygui_context_set_gui ( context, 
		"(window TITLE=\"EasyGUI: buttons\" NAME=\"win\" MAINWIN "
		"	(eqcols "
		"		(button name=\"btn_hello\" text=\"Hello\" action=\"btn_hello\" expand fill) "
		"		(button name=\"btn_change\" text=\"Change Label\" icon=\"@copy\" action=\"btn_change\") "
		"		(button name=\"btn_label\" text=\"Just a Label\" action=\"btn_hello\") "
		"	) "
		") "
	);

	if ( ( afc_res = afc_easygui_context_show ( context ) ) != AFC_ERR_NO_ERROR ) 
	{
		fprintf ( stderr, "res: %x\n", afc_res );
	} else 
		afc_easygui_main ( easygui );

	afc_easygui_delete ( easygui );
	afc_delete ( afc );

	return ( 0 ); 
}
