#include <afc/easygui/easygui.h>
#include <afc/easygui/widgets.h>

int chk_clicked ( DynamicClass * dc, EasyGUIContext * context, short val )
{
	fprintf ( stdout, "Checkbutton Clicked: %d\n", val );

	return ( 0 );
}

int btn_change ( DynamicClass * dc, EasyGUIContext * context )
{
	afc_easygui_widget_execute ( context, "chk_hello", "set_value", 1, AFC_EASYGUI_ARG_END );

	return ( 0 );
}

int main ( int argc, char * argv[] )
{
	AFC * afc = afc_new (); 
	EasyGUI * easygui = afc_easygui_new ( afc );
	EasyGUIContext * context;
	int afc_res = 0;

	if ( easygui == NULL ) 
	{
	  fprintf ( stderr, "Init of class EasyGUI failed.\n" );
	  return ( 1 );
	}

	afc_easygui_init ( easygui );
	context = afc_easygui_add_context ( easygui, NULL );

	afc_easygui_context_set_gui ( context, 
		"(window TITLE=\"EasyGUI: checkbutton\" MAINWIN "
		"	(eqcols "
		"		(checkbutton name=\"chk_hello\" text=\"Hello\" action=\"chk_clicked\" expand fill) "
		"		(button name=\"btn_change\" action=\"btn_change\" text=\"Set Checkbox\") "
		"	) "
		") "
	);

	if ( ( afc_res = afc_easygui_context_show ( context ) ) != AFC_ERR_NO_ERROR ) 
	{
		fprintf ( stderr, "res: %x\n", afc_res );
	} else 
		afc_easygui_main ( easygui );

	afc_easygui_delete ( easygui );
	afc_delete ( afc );

	return ( 0 ); 
}
