#include <afc/easygui/easygui.h>
#include <afc/easygui/widgets.h>

int entry_txt ( DynamicClass * dc, EasyGUIContext * context, char * txt )
{
	afc_easygui_widget_execute ( context, "label_txt", "set_text", txt, AFC_EASYGUI_ARG_END );

	return ( 0 );
}

int main ( int argc, char * argv[] )
{
	AFC * afc = afc_new (); 
	EasyGUI * easygui = afc_easygui_new ( afc );
	int afc_res = 0;

	if ( easygui == NULL ) 
	{
	  fprintf ( stderr, "Init of class EasyGUI failed.\n" );
	  return ( 1 );
	}

	afc_easygui_init ( easygui );

	afc_easygui_set_gui ( easygui, 
		"(window TITLE=\"EasyGUI: checkbutton\" MAINWIN "
		"	(rows "
		"		(label name=\"label_txt\" text=\"Hello World!\" expand fill) "
		"		(entry name=\"entry_txt\" action=\"entry_txt\") "
		"	) "
		") "
	);

	if ( ( afc_res = afc_easygui_show ( easygui ) ) != AFC_ERR_NO_ERROR ) 
	{
		fprintf ( stderr, "res: %x\n", afc_res );
	} else 
		afc_easygui_main ( easygui );

	afc_easygui_delete ( easygui );
	afc_delete ( afc );

	return ( 0 ); 
}
