#include <afc/easygui/easygui.h>
#include <afc/easygui/widgets.h>

int dummy ( DynamicClass * dc, EasyGUIContext * context )
{
	printf ( "Item Selected\n" );

	return ( 0 );
}

int toggle ( DynamicClass * dc, EasyGUIContext * context, short val )
{
	printf ( "Item Toggled: %d\n", val );

	return ( 0 );
}

int main ( int argc, char * argv[] )
{
	AFC * afc = afc_new (); 
	EasyGUI * easygui = afc_easygui_new ( afc );
	int afc_res = 0;

	if ( easygui == NULL ) 
	{
	  fprintf ( stderr, "Init of class EasyGUI failed.\n" );
	  return ( 1 );
	}

	afc_easygui_init ( easygui );

	afc_easygui_set_gui ( easygui, 
		"(window TITLE=\"Menu Test\" MAINWIN"
        	"  (rows "
                "	(menubar "
                "		(menu NAME=pippo TEXT=Hello ICON=@cut"
                "			(button NAME=menu_btn_hello TEXT=Hello ICON=@copy)"
                "			(button TEXT=\"Select Me\" ICON=@copy action=dummy)"
                "			(button TEXT=Hello ICON=@copy)"
                "			(separator)"
                "			(button TEXT=Hello ICON=@copy)"
                "			(button TEXT=\"Hello this is a <b>text</b>\" ICON=@paste)"
                "			(separator)"
                "			(checkbutton name=check_menu text=\"Check Me!\" action=toggle checked)"
                "		)"
		"	) "
		"  )"
                ")" );

	if ( ( afc_res = afc_easygui_show ( easygui ) ) != AFC_ERR_NO_ERROR ) 
	{
		fprintf ( stderr, "res: %x\n", afc_res );
	} else 
		afc_easygui_main ( easygui );

	afc_easygui_delete ( easygui );
	afc_delete ( afc );

	return ( 0 ); 
}
