#include <afc/easygui/easygui.h>
#include <afc/easygui/widgets.h>
int opt_menu_changed ( DynamicClass * dc, EasyGUIContext * context, int selected )
{
        printf ( "Option Menu, selected: %d (%p)\n", selected, context );
        return ( 0 );   
}

int entry_activate ( DynamicClass * dc, EasyGUIContext * context, const char * text )
{
        fprintf ( stderr, "Entry Activated: %s\n", text );

        afc_easygui_widget_execute ( context, "optm", "set", atoi ( text ), AFC_EASYGUI_ARG_END );

        return ( 0 );
}

int main ( int argc, char * argv[] )
{
	AFC * afc = afc_new (); 
	EasyGUI * easygui = afc_easygui_new ( afc );
	int afc_res = 0;

	if ( easygui == NULL ) 
	{
	  fprintf ( stderr, "Init of class EasyGUI failed.\n" );
	  return ( 1 );
	}

	afc_easygui_init ( easygui );

	afc_easygui_set_gui ( easygui, 
		"(window TITLE=titolo MAINWIN "
		"	(frame title=\"Hello I'm a Frame\" border=5 shadow=EOUT "
        	"		(rows "
                "			(optmenu name=\"optm\" CHANGED=opt_menu_changed "
                "				(button text=\"Option 0\")"
                "				(button text=\"Option 1\")"
                "				(button text=\"Option 2\")"
                "				(button text=\"Option 3\")"
                "				(button text=\"Option 4\")"
                "				(button text=\"Option 5\")"
                "				(button text=\"Option 6\")"
                "			)"
                "			(cols "
                "				(label text=\"New Value:\") "
                "				(entry MAXLEN=1 activated=entry_activate) " 
                "			)"
        	"		)"
		"	)"
		")" );


	if ( ( afc_res = afc_easygui_show ( easygui ) ) != AFC_ERR_NO_ERROR ) 
	{
		fprintf ( stderr, "res: %x\n", afc_res );
	} else 
		afc_easygui_main ( easygui );

	afc_easygui_delete ( easygui );
	afc_delete ( afc );

	return ( 0 ); 
}
