#include "../easygui.h"
#include "../widgets.h"

int btn_popup ( DynamicClass * dc, EasyGUIContext * context )
{
	afc_easygui_context_show_menu ( context, dc, "menu_popup" );
	return ( AFC_ERR_NO_ERROR );
}

int btn_hello ( DynamicClass * dc, EasyGUIContext * context )
{
	printf ( "Hello pressed\n" );
	return ( AFC_ERR_NO_ERROR );
}

int main ( int argc, char * argv[] )
{
	AFC * afc = afc_new (); 
	EasyGUI * easygui;
	EasyGUIContext * context;
	int afc_res = 0;

	afc_track_mallocs ( afc );

	afc_set_tags ( afc, AFC_TAG_LOG_LEVEL, 	AFC_LOG_WARNING, 
			    AFC_TAG_SHOW_FREES, FALSE,
			    AFC_TAG_SHOW_MALLOCS, FALSE,
			    AFC_TAG_END );

	easygui = afc_easygui_new ( afc );

	if ( easygui == NULL ) 
	{
		fprintf ( stderr, "Init of class EasyGUI failed.\n" );
	  	return ( 1 );
	}

	afc_easygui_init ( easygui );
	context = afc_easygui_add_context ( easygui, NULL );

	afc_easygui_context_set_gui_from_file ( context, "gui_menu_popup.egui" );

	//afc->debug_level = AFC_DEBUG_EVERYTHING; 

	if ( ( afc_res = afc_easygui_context_show ( context ) ) != AFC_ERR_NO_ERROR ) {
		fprintf ( stderr, "res: %x\n", afc_res );
	}
	else afc_easygui_main ( easygui );

	afc_easygui_delete ( easygui );

	afc_delete ( afc );

	return ( 0 ); 
}
