#include "../easygui.h"
#include "../widgets.h"

int btn_hello ( DynamicClass * dc, EasyGUIContext * context )
{
	printf ( "Hello!\n" );

	return ( AFC_ERR_NO_ERROR );
}

int btn_world ( DynamicClass * dc, EasyGUIContext * context )
{
	printf ( "World!\n" );

	return ( AFC_ERR_NO_ERROR );
}

int main ( int argc, char * argv[] )
{
	AFC * afc = afc_new (); 
	EasyGUI * easygui = afc_easygui_new ( afc );
	EasyGUIContext * context; 
	int afc_res = 0;

	if ( easygui == NULL ) 
	{
	  fprintf ( stderr, "Init of class EasyGUI failed.\n" );
	  return ( 1 );
	}

	afc_easygui_init ( easygui );
	context = afc_easygui_add_context ( easygui, AFC_EASYGUI_CONTEXT_MAIN );

	afc_easygui_context_set_gui_from_file ( context, "gui_toolbar.egui" );

	//afc->debug_level = AFC_DEBUG_EVERYTHING; 

	if ( ( afc_res = afc_easygui_context_show ( context ) ) != AFC_ERR_NO_ERROR ) {
		fprintf ( stderr, "res: %x\n", afc_res );
	}
	else afc_easygui_main ( easygui );

	afc_easygui_delete ( easygui );

	afc_delete ( afc );

	return ( 0 ); 
}
