/* AFC - The Advanced Foundation Classes
 * Copyright (C) 2001 - 2002 Fabio Rotondo and Andrea Galimberti
 *
 * This is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This software is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */
#include <stdlib.h>

#include "../test_utils.h"

int elements = 0;

HashMaster * hm;

int main ()
{
	AFC * afc = afc_new ();

	if ( afc == NULL ) return ( 1 );

	test_header ();

	hm = afc_hash_master_new ();

	afc_hash_master_add ( hm, 1,  ( void * ) 1 );
	afc_hash_master_add ( hm, 2,  ( void * ) 2 );
	afc_hash_master_add ( hm, 3,  ( void * ) 3 );
	afc_hash_master_add ( hm, 4,  ( void * ) 4 );

	afc_hash_master_find ( hm, 1 );
	afc_hash_master_del ( hm );

	afc_hash_master_delete ( hm );

	afc_delete ( afc );

	return ( 0 );
}

