#include "../../base.h"
#include "../../array_master.h"

int clear_func ( void * data )
{
	printf ( "FREE: %x\n", ( int ) data );
	if ( data ) afc_free ( data );
	return ( AFC_ERR_NO_ERROR );
}

int main ()
{
	AFC * afc = afc_new ();
	ArrayMaster * am;
	int t;
	
	afc_track_mallocs ( afc );
	afc_set_tags ( afc, 	AFC_TAG_LOG_LEVEL, 	AFC_LOG_WARNING, 
				AFC_TAG_SHOW_MALLOCS, 	TRUE,
				AFC_TAG_SHOW_FREES,	TRUE,
		       AFC_TAG_END );

	am = afc_array_master_new ();
	afc_array_master_set_clear_func ( am, clear_func );

	for ( t = 0; t < 10; t ++ )
	{
		if ( ! ( t % 2 ) )
			afc_array_master_add ( am, afc_malloc ( 10 ), AFC_ARRAY_MASTER_ADD_TAIL );
		else
			afc_array_master_del ( am );
	}

	printf ( "FINISHED!\n" );
	afc_delete ( afc );
	
	return ( 0 );
}

