/* AFC - The Advanced Foundation Classes
 * Copyright (C) 2001 - 2002 Fabio Rotondo and Andrea Galimberti
 *
 * This is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This software is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */
#include <stdlib.h>

#include "../test_utils.h"


RegExp * re;

int main ()
{
	AFC * afc = afc_new ();
	char * dest = afc_string_new ( 100 );

	if ( afc == NULL ) return ( 1 );

	test_header ();

	re = afc_regexp_new ();

	afc_regexp_compute_replace_size ( re, "aabbcc", "\\(.*\\)bb\\(.*\\)", "\\2bb\\1", TRUE );

	afc_regexp_compute_replace_size ( re, "aabbcc", "a", "cccc", TRUE );

	afc_regexp_compute_replace_size ( re, "aabbcc", "\\(.*\\)bbcc", "abc", TRUE );

	afc_delete ( afc );

	return ( 0 );
}

